#include "komfort_main.h"


/* Beginn Migration ATmega16 to ATmega644 */
#define TIMSK					TIMSK0
#define OCIE1A_					OCIE0B				// Gendert, wegen Doppeldefinition siehe uart.c --> #define USART_TXC_vect		TIMER1_COMPA_vect
#define OCR1A_					OCR0B				// Gendert, wegen Doppeldefinition siehe uart.c --> #define USART_TXC_vect		TIMER1_COMPA_vect
#define TIMER1_COMPA_vect_		TIMER0_COMPB_vect	// Gendert, wegen Doppeldefinition siehe uart.c --> #define USART_TXC_vect		TIMER1_COMPA_vect
/* Ende Migration ATmega16 to ATmega644 */



ISR(TIMER1_COMPA_vect_)
{
	event++; 																		// Erzeuge event in Software
}




void init()
{
	/*** Initialisierung fuer Atmega16 bzz. Atmega644***/
	DDRA = 0x00;
	//DDRB = (1 << PB3) | (1 << MOSI) | (1 << SS) | (1 << SCK);
	DDRB = (1 << PB3);
	DDRC = 0xFF;	
	DDRD = 0x00;


	TCCR1B = (1 << WGM12);
	TCCR1B |= (1 << CS11) | (1 << CS10);	// Prozessortakt / 64	-->		16MHz / 64 = 250kHz		-->	0,0000004 sec	
	OCR1A_ = 125;							// Vergleichsregister	--> alle 0,0000004 sec * 125 = 0,0005 sec wird der Timer aktiviert
	TIMSK = (1 << OCIE1A_);					// Aktiviert den Output Compare Interrupt,der ausgelst wird,
											// wenn das TCNTx Register mit den Wert des OCRx Registers bereinstimmt

	init_uart();

	sei();																				// Interrupts aktivieren
}



/*
 * Konfiguration fr ATmega644 20PU mit 16000000 MHz
 */
int main(void)
{
	//Hardware Initialisierungen
	init();

	for (;;) {
		// 5ms
		if (event >= 10) {
			event = 0;
			// TODO
		}
	}

}
